# Summary

# Hermes

---
- [Introduction](./index.md)
    - [What is Hermes?](./relayer.md)
- [Features](./features.md)
    - [Feature matrix](./feature_matrix.md)
- [Getting Started](./getting_started.md)
   - [Pre-requisites](./pre_requisites.md)
   - [Installation](./installation.md)
   - [Configuration](./config.md)
- [Tutorials](./tutorials.md)
   - [Two local chains](./two_chains.md)
     - [Install Gaia](./gaia.md)
     - [Start the local chains](./local_chains.md)
     - [Connect the chains using raw transactions](./tutorial_raw.md)
       - [Configure clients](./tutorial_client_raw.md)
       - [Connection handshake](./tutorial_conn_raw.md)
       - [Channel handshake](./tutorial_chan_open_raw.md)
       - [Relay packets](./tutorial_packet_raw.md)
     - [Connect the chains using relay paths](./tutorial_relay_paths.md)
       - [New path](./tutorial_set_new_path.md)
       - [Packet relaying on existing path](./tutorial_relay_existing_path.md)
       - [Packet relaying on new path](./tutorial_relay_new_path.md)
       - [Concurrent packet relaying on multiple paths](./tutorial_relay_two_paths.md)
- [Commands Reference](./commands.md)
   - [Keys](./keys.md)
   - [Light clients](./light_clients.md)
   - [Path setup and streaming](./relayer_loop.md)
   - [Raw transactions](./transactions.md)
     - [Client](./tx_client.md)
     - [Connection](./tx_connection.md)
     - [Channel Open](./tx_channel_open.md)
     - [Channel Close](./tx_channel_close.md)
     - [Packet](./tx_packet.md)
   - [Queries](./queries.md)
     - [Client](./query_client.md)
     - [Connection](./query_connection.md)
     - [Channel](./query_channel.md)
     - [Packet](./query_packet.md)
   - [Listen mode](./listen.md)
- [Help](help.md)
- [Glossary](./glossary.md)
---
